// AreaSelectGidlet.java
// Press Ok to start and stop selection
// Move area with cursor keys
// Change size with game keys (GAME_A, GAME_B, GAME_C, GAME_D)

import javax.microedition.lcdui.*;
import ch.aplu.gidlet.*;

public class AreaSelectGidlet extends Gidlet
{
  private MPanel p = new MPanel(0, 100, 0, 100);
  private double xCenter;
  private double yCenter;
  private double width;
  private double height;
  private boolean select = false;

  public void main()
  {
    p.addOkButton();
    p.addKeyListener(this);
    p.move(50, 50);
    p.fillCircle(30);
    p.savePanel();
  }

  public void doOk()
  {
    if (select)
    {
      select = false;
      p.addKeyListener(null);
      p.restorePanel();
      p.color(BLACK);
    }
    else
    {
      select = true;
      p.addKeyListener(this);
      xCenter = 50;
      yCenter = 50;
      width = 10;
      height = 10;
      p.color(RED);
      p.move(xCenter, yCenter);
      p.rectangle(width, height);
    }
  }

  public void keyPressed(int keyCode)
  {
    keyRepeated(keyCode);
  }

  public void keyRepeated(int keyCode)
  {
    int step = 5;
    boolean ok = false;
    switch (p.getGameAction(keyCode))
    {
      case Canvas.UP:
        yCenter += step;
        ok = true;
        break;

      case Canvas.DOWN:
        yCenter -= step;
        ok = true;
        break;

      case Canvas.LEFT:
        xCenter -= step;
        ok = true;
        break;

      case Canvas.RIGHT:
        xCenter += step;
        ok = true;
        break;

      case Canvas.GAME_A:
        width += step;
        ok = true;
        break;

      case Canvas.GAME_B:
        width -= step;
        ok = true;
        break;

      case Canvas.GAME_C:
        height += step;
        ok = true;
        break;

      case Canvas.GAME_D:
        height -= step;
        ok = true;
        break;
    }
    if (ok)
    {
      p.restorePanel();
      p.move(xCenter, yCenter);
      p.rectangle(width, height);
    }
  }
}
