// FileCreateGidlet.java

import ch.aplu.gidlet.*;

public class FileCreateGidlet extends Gidlet
{
  private final String dirPath = "root1/aplu/";
  private MConsole c =
    new MConsole(0, Gidlet.WHITE, Gidlet.BLUE, 1);

  public void main()
  {
    // Look for existing directory
    MFile mf = new MFile(dirPath);
    c.println("Looking for dir\n" +
               mf.getPath() + "...");
    if (mf.isDirectory())
    {
      c.println("Directory found.\nNo operation");
      return;
    }

    // Create directory
    c.println("Not found. Creating it...");
    if (mf.createDir())
      c.println("OK");
    else
    {
      c.println("createDir() failed");
      return;
    }

    // Create file
    mf.setPath(dirPath + "foo.txt");
    c.println("Creating empty file\n" +
               mf.getPath() + "...");
    if (mf.createFile())
      c.println("OK");
    else
    {
      c.println("createFile() failed");
      return;
    }

    // Try to remove directory
    mf.setPath(dirPath);
    c.println("Removing dir\n" +
               mf.getPath() + "...");
    if (mf.remove())
      c.println("OK");
    else
      c.println("remove() failed. Dir not empty");

    // Remove file
    mf.setPath(dirPath + "foo.txt");
    c.println("Removing file\n" +
               mf.getPath() + "...");
    if (mf.remove())
      c.println("OK");
    else
    {
      c.println("remove() failed.");
      return;
    }

    // Remove directory
    mf.setPath(dirPath);
    c.println("Removing dir\n" +
               mf.getPath() + "...");
    if (mf.remove())
      c.println("OK");
    else
    {
      c.println("remove() failed.");
      return;
    }
    c.println("All done");
  }
}

