// MmsReceiveGidlet.java

import javax.microedition.lcdui.*;
import javax.wireless.messaging.*;
import ch.aplu.gidlet.*;

public class MmsReceiveGidlet extends Gidlet
{
  private final String appId = "MmsGidlet";
  private MForm f;
  private MMSReader reader;

  public void main()
  {
    f = new MForm("Waiting for image by MMS...");
    f.show();
    reader = new MMSReader(appId);
  }

  public void notifyIncomingMMS(MultipartMessage mpm)
  {
    beep(3); // Alarm

    byte[] data = mpm.getMessagePart("id1").getContent();
    Image image = Image.createImage(data, 0, data.length);
    ImageItem imageItem =
      new ImageItem("Image received from " + mpm.getAddress(),
                     image, Item.LAYOUT_CENTER,
                     "Image not displayable");
    f.append(imageItem);
    f.append("Subject: " + mpm.getSubject());
  }

  public void doExit()
  {
    if (reader != null)
      reader.stop();
    notifyDestroyed();
  }
}