// ReactionGidlet.java

import javax.microedition.lcdui.*;
import java.util.*;
import ch.aplu.gidlet.*;

public class ReactionGidlet extends Gidlet
{
  private MPanel p;

  public void main()
  {
    String[] result =  new String[2];
    StringStore store = new StringStore("StateStore");
    String entry = store.read();

    if (entry == null) // Never played before
    {
      result[0] = "(never played)";
      result[1] = "?";
    }
    else
      result = split(entry, ";");

    MForm f = new MForm("Reaction Time");
    StringItem si = f.addOutputField();
    String info =  "Last test on\n" + result[0] +
                   "\n\nLast average score:\n" +
                   result[1] + " ms" +
                   "\n\nOK to start";
    si.setText(info);
    f.show();
    waitOk(true);
    p = new MPanel("When RED press FIRE");

    long average = play();  // Blocks until finished

    info = "Last average score:\n" + result[1] +
           " ms\n\nNew average score:\n" +
           Long.toString(average) + " ms";
    si.setText(info);
    f.removeOkButton();
    f.show();
    Date today = new Date();
    store.write(today + ";" + Long.toString(average));
  }

  private long play()
  {
    long score;
    long average = 0;
    p.addKeyListener(this);
    p.removeExitButton();
    p.move(0.5, 0.7);
    p.show();
    Random r = new Random();
    int nb = 5;
    for (int i = 0; i < nb; i++)
    {
      p.color(GREEN);
      p.fillCircle(0.1);
      startTimer();
      int delay = r.nextInt(3000) + 2000;
      while (getTime() < delay);  // Random wait
      p.color(RED);
      p.fillCircle(0.1);
      startTimer();
      putSleep();
      score = getTime();
      p.color(BLACK);
      p.label((i + 1)  + ". score: " +
       Long.toString(score) + " ms", 0.5 - 0.07*i);
      average += score;
    }
    p.label("OK to recapitulate", 0.5 - 0.07*nb);
    waitOk(true);
    return average / 5;
  }

  public void keyPressed(int keyCode)
  {
    if (p.getGameAction(keyCode) == Canvas.FIRE)
      wakeUp();
  }
}
