// SearchGidlet.java
// Uses JSR 238 "Mobile Internationalization API"

import ch.aplu.gidlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.global.*;

public class SearchGidlet extends Gidlet
{
  public void main()
  {
    String in = "Alpha Beta Gamma Delta";
    String[] a = split(in, " ");
    showMessage("Search in\n" + in);
    String key = readString("Enter search key");
    int index = binarySearch(a, key);
    if (index < 0)
      showMessage("not found", false);
    else
      showMessage("found at index " + index, false);
  }

  private int binarySearch(String[] a, String searchKey)
  {
    // If searchKey is found in a, return array index, otherwise return -1
    return recFind(a, searchKey, 0, a.length - 1);
  }

  private int recFind(String[] a, String searchKey, int lowerBound, int upperBound)
  {
    StringComparator sc = new StringComparator();

    int index;

    index = (lowerBound + upperBound) / 2;
    if (a[index].equals(searchKey))
      return index; // Found it
    else
    {
      if (lowerBound > upperBound)
        return -1; // Did not find it
      else // Divide range ("divide and conquer")
      {

        int rc = sc.compare(a[index], searchKey);
        if (rc < 0) // In upper half
          return recFind(a, searchKey, index + 1, upperBound);
        else
          // In lower half
          return recFind(a, searchKey, lowerBound, index - 1);
      }
    }
  }
}

