// SmsReceiveGidlet.java

import javax.wireless.messaging.*;
import ch.aplu.gidlet.*;

public class SmsReceiveGidlet extends Gidlet
{
  private final int portnumber = 5000;
  private MConsole c;
  private SMSReader reader;

  public void main()
  {
    c = new MConsole();
    c.color(YELLOW);
    c.println("Waiting for SMS on port " + portnumber);
    reader = new SMSReader(portnumber);
  }

  public void notifyIncomingSMS(TextMessage msg)
  {
    beep(3); // Alarm

    c.color(YELLOW);
    c.println("Received on:");
    c.color(WHITE);
    c.println(msg.getTimestamp().toString());
    c.color(YELLOW);
    c.println("Sender:");
    c.color(WHITE);
    c.println(msg.getAddress());
    c.color(YELLOW);
    c.println("Message:");
    c.color(WHITE);
    c.println(msg.getPayloadText());
  }

  public void doExit()
  {
    if (reader != null)
      reader.stop();
    notifyDestroyed();
  }
}