// VocCreateGidlet.java

/*
File structure:

deutsches_wort|english_word<cr><lf>
deutsches_wort|english_word<cr><lf>
*/

import ch.aplu.gidlet.*;
import javax.microedition.lcdui.*;

public class VocCreateGidlet extends Gidlet
{
  private TextField tf1;
  private TextField tf2;
  private StringItem it;
  private MForm f;
  private MFile mf = new MFile();
  private int recordNb;

  public void main()
  {
    mf.findFirstRoot();
    if (mf.getPath().equals("c:/"))  // No access on c:, try next
      mf.findNextRoot();
    mf.setPath(mf.getPath() + "voc/");
    if (!mf.exists())
      mf.createDir();
    mf.setPath(mf.getPath() + "lesson1");
    if (!mf.exists())
      mf.createFile();

    f = new MForm("File: " + mf.getPath());
    tf1 = f.addInputField("Deutsch:", "");
    tf2 = f.addInputField("English:", "");
    it = f.addOutputField();
    recordNb = getRecordNb();
    if (recordNb >= 0)
    {
      it.setText("# records: " + recordNb);
      f.addOkButton();
    }
    f.show();
  }

  public void doOk()
  {
    String s1 = f.getText(tf1);
    String s2 = f.getText(tf2);
    if (validate(s1) && validate(s2))
    {
      mf.append(s1 + "|" + s2 + "\r\n");
      recordNb++;
      it.setText("# records: " + recordNb);
      tf1.setString("");  // Erase
      tf2.setString("");  // Erase
      display.setCurrentItem(tf1);  // Set focus on tf1
    }
    else
      it.setText("Illegal entry");
  }

  private int getRecordNb()
  {
    String content = mf.read();

    if (content == null)
    {
      it.setText("Read of vocabulary file failed");
      return -1;
    }

    if (content.equals(""))
      return 0;  // Empty file

    String[] records = split(content, "\r\n");
    // Last line terminates with separator,
    // so the last record is empty
    return records.length - 1;
  }

  private boolean validate(String s)
  {
    if (s.equals(""))
      return false;
    if (s.indexOf('|') != -1)
      return false;
    return true;
  }
}