// VolumeAudioGidlet.java

import javax.microedition.lcdui.*;
import javax.microedition.media.control.*;
import ch.aplu.gidlet.*;

public class VolumeAudioGidlet extends Gidlet
  implements ItemStateListener, CommandListener
{
  private final String uri = "http://www.aplu.ch/g/b.wav";

  private Command exitCommand = new Command("Exit", Command.EXIT, 1);
  private Command startCommand = new Command("Start", Command.OK, 1);
  private Command pauseCommand = new Command("Pause", Command.OK, 1);
  private Command stopCommand = new Command("Stop", Command.OK, 1);

  private MForm f;
  private AudioPlayer ap;
  private VolumeControl volume;
  private Gauge gauge;
  private StringItem si;

  public void main()
  {
    f = new MForm("AudioPlayer");
    f.removeExitButton();
    f.show();
    f.setTitle("Loading. Please wait...");
    ap = new AudioPlayer(uri);
    if (ap.getPlayer() == null)
    {
      showMessage("Access to the internet denied", false);
      return;
    }
    f.setTitle("Ready");

    int init = 8;
    int maxValue = 10;
    gauge = new Gauge("Volume", true, maxValue, init); // Interactive
    si = new StringItem(null, "Volume = " + init);
    volume = (VolumeControl)ap.getPlayer().getControl("VolumeControl");
    volume.setLevel(10*init);

    f.addCommand(exitCommand);
    f.addCommand(startCommand);
    f.addCommand(pauseCommand);
    f.addCommand(stopCommand);
    f.setCommandListener(this);
    f.setItemStateListener(this);
    f.append(gauge);
    f.append(si);
  }

  public void notifyapUpdate(String event, Object eventData)
  {
    if (event.equals("readyToStart"))
      f.setTitle("Ready to start");
    if (event.equals("endOfMedia"))
      f.setTitle("Finished");
  }

  public void itemStateChanged(Item item)
  {
    if (item == gauge)
    {
      int value = gauge.getValue();
      si.setText("Volume = " + value);
      volume.setLevel(10 * value); // 0..100
    }
  }

  public void commandAction(Command c, Displayable d)
  {
    if (c == exitCommand)
    {
      ap.close();
      notifyDestroyed();
    }
    if (c == startCommand)
    {
      ap.start();
      f.setTitle("Playing...");
    }
    if (c == pauseCommand)
    {
      ap.pause();
      f.setTitle("Pausing...");
    }
    if (c == stopCommand)
    {
      ap.stop();
      f.setTitle("Stopped");
    }
  }

}