// TempSensorGidlet.java

import ch.aplu.gidlet.*;
import ch.aplu.nxt.*;

public class TempSensorGidlet extends Gidlet
{
  private final int securityLevel = 25;  // Degrees
  private final int delayTime = 2000;  // ms
  private NxtRobot robot;
  private volatile boolean isRunning = true;

  public void main()
  {
    robot = new NxtRobot(null, false);
    if (!robot.connect())
      return;
    MConsole c = new MConsole(0, WHITE, BLACK, 2);
    c.println("Remote Temperature");
    TemperatureSensor ts = new TemperatureSensor(SensorPort.S1);
    robot.addPart(ts);
    int time = 0;
    while (isRunning)
    {
      double value = ts.getDegrees();
      c.println("At " + time/1000 + " s: " + value + " deg.");
      if (value > securityLevel)
      {
        c.println("  Temperature too high");
        beep(2);
      }
      Tools.delay(delayTime);
      time += delayTime;
    }
  }

  public void doExit()
  {
    isRunning = false;
    robot.exit();
  }
}
