// ConnectPanel.java, Java ME version
// Platform (Java SE, ME) dependent code
// Should be visible in package only. Not includeded in Javadoc

/*
This software is part of the NxtJLib library.
It is Open Source Free Software, so you may
- run the code for any purpose
- study how the code works and adapt it to your needs
- integrate all or parts of the code in your own programs
- redistribute copies of the code
- improve the code and release your improvements to the public
However the use of the code is entirely your responsibility.
 */

package ch.aplu.nxt.platform;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import ch.aplu.gidlet.*;
import ch.aplu.nxt.*;

/**
 * Message forms with standard title.
 */
public class ConnectPanel implements SharedConstants
{
  // ------------- Inner class MyCommandListener -------------
  private static class MyCommandListener implements CommandListener
  {
    public void commandAction(Command c, Displayable d)
    {
      if (c == okCommand)
      {
        btName = askForm.getText(tf);
        if (btName.trim().length() != 0)
        {
          StringStore store = new StringStore("nxtstore");
          store.write(btName);
          PlatformTools.wakeUp();
        }
        else
          si2.setText("Illegal entry");
      }
    }
  }

  private static StringItem si1;
  private static StringItem si2;
  private static TextField tf;
  private static MForm askForm;
  private static MForm connectForm;
  private static ConnectPanel cp = null;
  private static String btName;
  private static Command okCommand = new Command("OK", Command.OK, 1);

  private ConnectPanel()
  {
    connectForm = new MForm(TITLEMP);
    si1 = connectForm.addOutputField();
    connectForm.show();
    cp = this;
 }

  /**
   * Creates a form with an output field and shows the given text.
   * Returns immediately. If the form is already created, replaces the
   * text. If the form is hidden, shows it with the given text.
   * @param text the text to display
   */
  public static void show(String text)
  {
    if (cp == null)
      create();
    si1.setText(text);
    connectForm.show();
  }

  private static void create()
  {
    if (cp == null)
      new ConnectPanel();
  }

  /**
   * Shows a form with a input field and
   * asks for Bluetooth friendly name.
   * @return the trimmed string entered when the OK button is hit.
   */
  public static String askBtName()
  {
    String prompt = "Enter Bluetooth Name";
    String title = TITLEMP;
    askForm = new MForm(title);
    askForm.addCommand(okCommand);
    askForm.removeExitButton();
    askForm.setCommandListener(new MyCommandListener());
    tf = askForm.addInputField(prompt, "");
    si2 = askForm.addOutputField();
    StringStore store = new StringStore("nxtstore");
    String content = store.read();
    if (content != null)
      tf.setString(content);
    else
    {
      NxtProperties props = NxtRobot.getProperties();
      String btName =  props.getStringValue("BluetoothName");
      tf.setString(btName);
    }
    askForm.show();
    PlatformTools.putSleep();
    return btName;
  }


  public static void hide()  // Empty in J2ME
  {}
}

